/* Listing1:  Clemens Marschner, 1994 */

#include <exec/types.h> 
#include <string.h>
#include <stream.h>

template <class Typ> // Typ ist ein beliebiger Platzhalter.
inline Typ Max(Typ a, Typ b) {
    return ( a > b ? a : b );
}

/* Maximum-Funktion: Gibt den greren Wert zurck.
   Max kann fr alle Typen verwendet werden, die den
   Operator ">" berladen haben. Damit ein Zeiger, z.B.
   char*, nicht einfach als Zeigerwert verglichen wird,
   sondern dessen Inhalt, mu man das Funktions-Template
   berladen. Diese Definition hat Vorrang vor dem Template */

inline char *Max(char* a, char* b) {
    return (strcmp(a,b) > 0 ? a : b);
}

void main() {
    char *a = "Peter", *b = "Meyer";
    int   c = 38,       d = 18;
    cout << Max(a, b) << ", " << Max(c,d) << "\n";
    // Ausgabe: Peter,38
    // cout << Max(a, c); <- Fehler im Gegensatz zu #define
}
